.\"Copyright 1989, 1990, 1991 by Chris Lewis 1.3 92/03/05
.TH HP2PBM %%MANEXT%% "standalone"
.SH NAME
hp2pbm,hp2hifax,hp2lofax,hp2sun,hp2e24,hp2hig3,hp2log3 \- Translate HPLJ codes to PostScript or PBM or G3
.SH SYNOPSIS
.B hp2pbm
.B "[\-v]"
.B "[\-V]"
.B "[\-p]"
.B "[\-c]"
.BI "[\-r" pbmfile "]"
.BI "[\-d" x "[," y "]]"
< HP codes
.SH DESCRIPTION
The
.B hp2pbm
program (linked to any of its aliases) is a program that interprets HP PCL
(Hewlett Packard Printer Control Language - the language of HP Laserjets)
escape code sequences.
.B Hp2pbm
is intended to be fully compliant with HP's ``PCL4''-level language.
Which means it should fully emulate any of HP's printers except for
some features of the HP Laserjet III.
.B Hp2pbm
can then generate an english description of the codes, translate the input
into PostScript, or generate PBM files (Jef Poskanzer's Portable Bitmap Format),
or generate G3 format files for G3 FAX modems.
.P
.B "hp2pbm -V"
prints the version string.
.P
.B Hp2pbm
is essentially a version of the
.B hpinterp
program
that has been extended to optionally emit PBM.
.B Hpinterp
is a part of
.BR psroff .
This can be considered to be an ``after market'' optional upgrade
to
.BR psroff .
.P
.B Hp2pbm
will accept input from
.B any
HP PCL-generating program, such as
.B psroff
(C/A/T troff or ditroff converter),
.B jetroff
(ditroff converter),
.BR WordPerfect ,
.BR CorelDraw ,
including (some) built in and all downloaded fonts (except
compressed ones) and including built in and downloaded graphics and rasters.
.B Hp2pbm
does not support PCL5 features such as scalable fonts and HPGL.
.B Hp2pbm
can be used to drive a number of different configurations, such as
PostScript printers, Klaus Schallhorn's
.B faxpak
(to transmit faxes using a fax modem),
or other devices using PBM converters, such as Epson 24 pin printers,
Sun displays, 3b1 consoles etc.
With the G3 variants, such as
.B hp2hig3
or
.BR hp2log3 ,
G3 format files can be generated directly without going through an
additional PBM step.
.P
If the
.B \-v
option is specified,
.B hp2pbm
will emit english descriptions of all of the HP PCL escape sequences to
standard output.
This is useful for debugging HP PCL emitting programs.
.P
The
.B \-p
option tells
.B hp2pbm
to emit PostScript to standard output.
Specifying both \-v and \-p at the same time is rather confusing.
Note: unless
.B hp2pbm
is used with the rest of the
.B psroff
utility set (namely,
.B lj2ps
and
.BR pk2ps ),
.B hp2pbm
does not support fonts that were downloaded in the HP Laserjet print
stream.
.P
Unless the
.B \-r
option is specified,
.B hp2pbm
will collect any fonts in the HP PCL and save them in files in a
directory called ``./FONTS'', with the nameing convention
.BI f n
where \f2n\fP is the HP PCL font ID number.
The ``FONTS'' directory should be created manually before running
.B hp2pbm .
A file called
.BI f n .desc
is also created in the ``FONTS'' directory, which contains a description of
each character.
If the \-c option is specified, an ASCII drawing will be made
of each glyph in the font in the
.B .desc
file.
This is very useful for examining HP PCL fonts, whether they are
individual font files, or are embedded in HP PCL print streams.
.P
If the
.BI \-r value
option is specified,
hp2??fax and hp2e24 create PBM files.
hp2??g3 creates G3 files.
The associated argument is the basename for the generated files.
The first page is named ``value.0'', second ``value.1'' etc.
If
.I value
has a pipe symbol (``|'') as the first character, the rest
.I value
is used as a pipeline to send each page.
Hence, for example, you can use
.B hp2pbm
with psroff like so:
.sp
.nf
.in +1i
psroff -Tlj -t file | hp2e24 '-r|pbm2e24' | lp
.in -1i
.fi
.P
The \-d option specifies a resolution not automatically assumed
from argv[0].
It is specified as
.BI \-d x , y
where
.I x
is the horizontal resolution in dots per inch, and
.I y
is the vertical resolution in dots per inch.
If the
.BI , y
clause is omitted, it defaults to the
.I x
value.
.P
The default dots per inch for
.B Hp2pbm
is 300.
.B Hp2pbm
is also linked to several different names as a convenience
for supplying the dots per inch.
The names are: hp2hifax (high resolution PBM FAX), hp2lofax
(low resolution PBM FAX)
hp2sun (Sun mono display), hp2e24 (Epson 24 pin printer at 180 dpi),
hp2log3 (low resolution G3 FAX), and hp2hig3 (high resolution G3 FAX).
.SH FILES
.if t .ta 2.5i
.if n .ta 3.5i
./FONTS/f<n>	Parsed-out SFP's
.br
./FONTS/f<n>.desc	English descriptions
.br
%%LIBDIR%%/BITMAPS	rasters, patterns and builtin font clones.
.SH "SEE ALSO"
Hewlett Packard Laserjet documentation.
Adobe Systems PostScript documentation.
.SH WARNINGS
.P
.B "Hp2pbm output can be huge!"
PBM file sizes are resolution dependent.
At 300DPI a legal size sheet is 1.2 megabytes
.B "PER PAGE" !
.P
.B "Hp2pbm's"
handling of downloaded macros is not fully tested.
Compressed fonts, scalable built in fonts, and HPGL mode
personalities in PCL5 are not supported.
Except for these limitations
.B Hp2pbm
should be fully compatible with all HP Laserjet printers.
.P
The
.B \-p
option was implemented soley as a test jig for the HP PCL output
option of
.B "psroff \-Tlj"
without having a laserjet printer.
The PostScript generating code isn't complete, but this will
probably be rectified in future.
.P
.B Hp2pbm
will not create a FONTS directory if one doesn't exist, and will die if
there isn't one.
.P
.B "Hp2pbm \-p"
will attempt to do something sane with selecting a font by characteristic,
but be warned, these use the printer's built-in fonts (which are likely
to be radically different from a LJ's), so the widths may be different and
the mappings of non-ASCII characters certainly will be.
.PP
Most PostScript printers have relatively little memory for additional
bitmapped fonts.
Do not be surprised by VMerrors from your PostScript printer if you've
selected more than a few fonts in your Laserjet output.
.SH AUTHORS
This manual page and the HP PCL parsing code was written by Chris Lewis,
as was psroff.
The PBM generation code was written by Klaus Schallhorn.
The G3 code was written by Paul Haeberli and Jef Poskanzer and
appears in PBMPLUS, and was integrated into hp2pbm by Roberto Biancardi.
