/*
    Copyright 1989, 1990, 1991 Chris Lewis
    All Rights Reserved

    Permission to copy and further distribute is freely given provided
    this copyright notice remains intact, that this software is not
    sold for profit, that credit is given, and that sources will be made
    available on request.

    This software is a subset of Psroff 3.0.  See the LICENSE file
    in Psroff 3.0 for more details, or contact:

	Chris Lewis
	Box 124
	Dunrobin, Ontario
	Canada K0A 1T0
	(613) 832-0541

    Function: Very stupid PBM to PS converter.
	      I hope you have a parallel interface!
 */

#ifndef	lint
static char SCCSID[] =
    "@(#)pbm2ps.c 1.1 92/04/01 01:45:04";
#endif
#include "hptopbm.h"

#define	RES	300

#ifdef	LETTER
#define	YLEN	((double) 11)
#define	XLEN	((double) 8.5)
#endif

#define	YMAX	(YLEN * RES)
#define	XMAX	(XLEN * RES)

#define	FASTER
#ifdef FASTER
char hex[] = "0123456789abcdef";
#endif

emitps(numx, numy, image)
int numx;
int numy;
char *image; {
    register long total, i;
    int bperline;
    int yoffset;
    register char *p;
    register int t;
    int skiplines;

    yoffset = YMAX - numy;	/* in pixels */

    bperline = ((numx + 7) / 8);
    total = bperline * numy;

    /* strip excess baggage from front of raster */

    for (p = image; p - image < total && !(*p); p++) ;
    skiplines = (p - image) / bperline;

    image = image + skiplines * bperline;
    numy = numy - skiplines;
    total = bperline * numy;

    /*fprintf(stderr, "Stripped %d lines from front\n", skiplines);*/

    /* strip excess baggage from end of raster */

    for (p = &image[total]; p > image && !(*p); p--) ;
    skiplines = numy - (p - image) / bperline - 1;
    numy -= skiplines;
    yoffset += skiplines;

    /*fprintf(stderr, "Stripped %d lines from end\n", skiplines);*/

    total = bperline * numy;

    /* end strip */
    printf("%%!PS-Adobe-2.0\n");
    printf("%%%%EndComments\n");
    printf("/DataString %d string def\n", bperline);
    printf("%%%%EndProlog\n");
    printf("%%Page: 1 1\n");
    printf("0 %f translate\n", (double) yoffset / 300 * 72);
    printf("%f %f scale\n", (numx / XMAX) * XLEN * 72,
			    (numy / YMAX) * YLEN * 72);
    printf("%d %d 1 [ %d 0 0 -%d 0 %d ]\n", numx, numy, numx, numy, numy);
    printf("{\n");
    printf("    currentfile DataString readhexstring pop\n");
    printf("} bind image\n");
    for (p = image, i = 0; i < total; p++, i++) {
#ifdef	FASTER
	t = ((*p) & 0xff) ^ 0xff;
	putchar(hex[(t >> 4)&0xf]);
	putchar(hex[t&0xf]);
#else
	printf("%02x", (*p) & 0xff);
#endif
	if ((i % 40) == 39)
	    putchar('\n');
    }
    printf("\n\nshowpage\n");
    printf("%%%%Trailer\n");
}

char str[] =
    {0xdd, 0xff, 0x00, 0xff, 0x54, 0x1f, 0x80, 0x03, 0xfb, 0xf9, 0x00, 0x1e };
main() {
    long x, y;
    long count;
    register char *p;
    register char *buffer;
    char b[30];

    gets(b);
    if (strcmp(b, "P4")) {
	fprintf(stderr, "Not a PBM\n");
	exit(1);
    }
    gets (b);
    if (2 != sscanf(b, "%ld %ld", &x, &y)) {
	fprintf(stderr, "Not a PBM\n");
	exit(1);
    }
    count = ((x + 7) / 8) * y;
    buffer = malloc(count);
    if (!buffer) {
	fprintf(stderr, "Couldn't malloc raster buffer\n");
	exit(1);
    }

    /*fprintf(stderr, "Trying to read %ld bytes\n", count);*/
    if (fread(buffer, 1, count, stdin) != count) {
	fprintf(stderr, "Couldn't read the bitmap properly\n");
	exit(1);
    }
    emitps(x, y, buffer);
    exit(0);
}
