/*
    Copyright 1989, 1990, 1991 Chris Lewis
    All Rights Reserved

    Permission to copy and further distribute is freely given provided
    this copyright notice remains intact, that this software is not
    sold for profit, that credit is given, and that sources will be made
    available on request.

    This software is a subset of Psroff 3.0.  See the LICENSE file
    in Psroff 3.0 for more details, or contact:

	Chris Lewis
	Box 124
	Dunrobin, Ontario
	Canada K0A 1T0
	(613) 832-0541

    Function: Creates xwd format files from PBM.  Permits
	      X window display by xwud.
 */

#ifndef	lint
static char SCCSID[] =
    "@(#)pbm2Xd.c 1.2 92/04/01 02:44:44";
#endif
#include "hptopbm.h"

typedef long xwdval;

#define XWD_FILE_VERSION 7

typedef struct _xwd_file_header {
	xwdval header_size;	  /* Size of the entire file header (bytes). */
	xwdval file_version;	  /* XWD_FILE_VERSION */
	xwdval pixmap_format;	  /* Pixmap format */
	xwdval pixmap_depth;	  /* Pixmap depth */
	xwdval pixmap_width;	  /* Pixmap width */
	xwdval pixmap_height;	  /* Pixmap height */
	xwdval xoffset;           /* Bitmap x offset */
	xwdval byte_order;        /* MSBFirst, LSBFirst */
	xwdval bitmap_unit;       /* Bitmap unit */
	xwdval bitmap_bit_order;  /* MSBFirst, LSBFirst */
	xwdval bitmap_pad;	  /* Bitmap scanline pad */
	xwdval bits_per_pixel;	  /* Bits per pixel */
	xwdval bytes_per_line;	  /* Bytes per scanline */
	xwdval visual_class;	  /* Class of colormap */
	xwdval red_mask;	  /* Z red mask */
	xwdval green_mask;	  /* Z green mask */
	xwdval blue_mask;	  /* Z blue mask */
	xwdval bits_per_rgb;	  /* Log base 2 of distinct color values */
	xwdval colormap_entries;  /* Number of entries in colormap */
	xwdval ncolors;		  /* Number of Color structures */
	xwdval window_width;	  /* Window width */
	xwdval window_height;	  /* Window height */
	long window_x;		  /* Window upper left X coordinate */
	long window_y;		  /* Window upper left Y coordinate */
	xwdval window_bdrwidth;	  /* Window border width */
} XWDFileHeader;

dump(argc, argv)
int argc;
char **argv; {
    XWDFileHeader *d;
    char *p;
    xwdval v;
    extern char *malloc();
    int i;

    fread(&v, sizeof(d->header_size), 1, stdin);
    printf("Header size is %ld, struct is: %d\n", v, sizeof(*d));
    d = (XWDFileHeader *) malloc(v);
    d->header_size = v;
    fread(&d->file_version, sizeof(*d) - sizeof(d->header_size), 1, stdin);
    printf("Size of the entire file header (bytes).: %ld\n", d->header_size);
    printf("XWD_FILE_VERSION: %ld\n", d->file_version);
    printf("Pixmap format: %ld\n", d->pixmap_format);
    printf("Pixmap depth: %ld\n", d->pixmap_depth);
    printf("Pixmap width: %ld\n", d->pixmap_width);
    printf("Pixmap height: %ld\n", d->pixmap_height);
    printf("Bitmap x offset: %ld\n", d->xoffset);
    printf("MSBFirst, LSBFirst: %ld\n", d->byte_order);
    printf("Bitmap unit: %ld\n", d->bitmap_unit);
    printf("MSBFirst, LSBFirst: %ld\n", d->bitmap_bit_order);
    printf("Bitmap scanline pad: %ld\n", d->bitmap_pad);
    printf("Bits per pixel: %ld\n", d->bits_per_pixel);
    printf("Bytes per scanline: %ld\n", d->bytes_per_line);
    printf("Class of colormap: %ld\n", d->visual_class);
    printf("Z red mask: %ld\n", d->red_mask);
    printf("Z green mask: %ld\n", d->green_mask);
    printf("Z blue mask: %ld\n", d->blue_mask);
    printf("Log base 2 of distinct color values: %ld\n", d->bits_per_rgb);
    printf("Number of entries in colormap: %ld\n", d->colormap_entries);
    printf("Number of Color structures: %ld\n", d->ncolors);
    printf("Window width: %ld\n", d->window_width);
    printf("Window height: %ld\n", d->window_height);
    printf("Window upper left X coordinate: %ld\n", d->window_x);
    printf("Window upper left Y coordinate: %ld\n", d->window_y);
    printf("Window border width: %ld\n", d->window_bdrwidth);
    p = (char*) d;
    for (i = sizeof(*d); i < d->header_size; i++)
	printf("%02x", p[i]);
    putchar('\n');
}

emitX(x, y, buffer)
int x, y;
char *buffer; {
    XWDFileHeader d;
    d.header_size = 100;
    d.file_version = 7;
    d.pixmap_format = 2;
    d.pixmap_depth = 1;
    d.pixmap_width = x;
    d.pixmap_height = y;
    d.xoffset = 0;
    d.byte_order = 1;
    d.bitmap_unit = 32;
    d.bitmap_bit_order = 1;
    d.bits_per_pixel = 1;
    d.bytes_per_line = (x + 7) / 8;
    d.visual_class = 0;
    d.red_mask = 0;
    d.green_mask = 0;
    d.blue_mask = 0;
    d.bits_per_rgb = 0;
    d.colormap_entries = 0;
    d.ncolors = 0;
    d.window_width = x;
    d.window_height = y;
    d.window_x = 50;
    d.window_y = 50;
    d.window_bdrwidth = 0;
    fwrite(&d, 1, sizeof(d), stdout);
    fwrite(buffer, d.bytes_per_line * y, 1, stdout);
}

main(argc, argv)
int argc; char **argv; {
    long x, y;
    long count;
    register char *p;
    register char *buffer;
    char b[30];

    if (argc != 1) {
	dump(argc, argv);
	exit(0);
    }

    gets(b);
    if (strcmp(b, "P4")) {
	fprintf(stderr, "Not a PBM\n");
	exit(1);
    }
    gets (b);
    if (2 != sscanf(b, "%ld %ld", &x, &y)) {
	fprintf(stderr, "Not a PBM\n");
	exit(1);
    }
    count = ((x + 7) / 8) * y;
    buffer = malloc(count);
    if (!buffer) {
	fprintf(stderr, "Couldn't malloc raster buffer\n");
	exit(1);
    }

    /*fprintf(stderr, "Trying to read %ld bytes\n", count);*/
    if (fread(buffer, 1, count, stdin) != count) {
	fprintf(stderr, "Couldn't read the bitmap properly\n");
	exit(1);
    }
    emitX(x, y, buffer);
    exit(0);
}
